#pragma once
#include "datatypes.h"
#include <QMap>
#include <QString>
#include <QList>

/*!
* FileParser reads an input stream from a given file location and tries to parse it to different data structures acoording to the structure it gets passed as an argument.
*/
class FileParser {
public:
	void	setPattern(QList<QString>);

	template<typename TYPE>
	bool read(QString filename, TYPE &list);

protected:
	bool	parseFromString(QList<Airport*>&, QString);
	bool	parseFromString(QList<Route*>&, QString);
	bool	parseFromString(QMap<QString, int>&, QString);
	bool	parseFromString(QMap<int, int>&, QString);
};

